# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without maven
%bcond_without repolib

%define base_name cli
%global short_name commons-%{base_name}
%define section free

%define reltag _redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           apache-commons-cli
Version:        1.2
Release:        6.3%{?reltag}%{?dist}.1
Epoch:          0
Summary:        Command-Line Interface for Java
License:        ASL 2.0
Group:          Development/Java
URL:            http://commons.apache.org/cli/
Source0:        http://www.apache.org/dist/commons/%{base_name}/source/%{short_name}-%{version}-src.tar.gz
Source4:        apache-commons-cli-build.xml
Source5:        apache-commons-cli-maven-build.xml
Source6:        apache-commons-cli-maven-build.properties
Source7:        apache-commons-cli-osgi-MANIFEST.MF
Source8:        javase-6-package-list
Patch0:         commons-cli-pom.patch
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  ant-junit
BuildRequires:  ant-junit4
BuildRequires:  junit4
# XXX
BuildRequires:  jakarta-commons-lang
BuildRequires:  apache-commons-logging
%if %with maven
BuildRequires:  apache-commons-parent >= 0:12
BuildRequires:  cobertura-maven-plugin
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-resources
%endif
Requires:       java >= 0:1.6.0
# XXX: (dwalluck): These are optional
#Requires:       jakarta-commons-lang
#Requires:      apache-commons-logging
Provides:       jakarta-%{short_name} = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name} < %{epoch}:%{version}-%{release}
Provides:       %{short_name} = %{epoch}:%{version}-%{release}
#Obsoletes:      %{short_name} < %{epoch}:%{version}-%{release}
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The CLI library provides a simple and easy to use API for working with
the command line arguments and options.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java
Provides:       jakarta-%{short_name}-repolib = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-repolib < %{epoch}:%{version}-%{release}
Provides:       %{short_name}-repolib = %{epoch}:%{version}-%{release}
#Obsoletes:      %{short_name}-repolib < %{epoch}:%{version}-%{release}

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java
BuildRequires:  java-javadoc
Provides:       jakarta-%{short_name}-javadoc = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-javadoc < %{epoch}:%{version}-%{release}
Provides:       %{short_name}-javadoc = %{epoch}:%{version}-%{release}
#Obsoletes:      %{short_name}-javadoc < %{epoch}:%{version}-%{release}
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{short_name}-%{version}-src
%patch0 -p1 -b .sav0
%{__perl} -pi \
    -e 's/\r$//g;' \
  PROPOSAL.html LICENSE.txt NOTICE.txt RELEASE-NOTES.txt

%if %with maven
%else
cp %{SOURCE4} build.xml
cp %{SOURCE5} maven-build.xml
cp %{SOURCE6} maven-build.properties
mkdir -p target/osgi/
cp %{SOURCE7} target/osgi/MANIFEST.MF
cp %{SOURCE8} package-list
%endif

%build
%if %with maven
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
%else
export OPT_JAR_LIST="ant/ant-junit ant/ant-junit4 junit4"
export CLASSPATH=$(build-classpath commons-logging commons-lang)
export CLASSPATH="$CLASSPATH:target/classes:target/test-classes"
 # for tests
mkdir lib
%{ant} \
  -Dmaven.mode.offline=true \
  jar javadoc
%endif

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p target/%{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-%{namedversion}.jar
#ln -s %{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}.jar
#ln -s %{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-%{namedversion}.jar
ln -s %{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}.jar
ln -s %{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/jakarta-%{short_name}-%{namedversion}.jar
ln -s %{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/jakarta-%{short_name}.jar

# Install pom file
mkdir -p %{buildroot}%{_mavenpomdir}
cp -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}.pom
%add_to_maven_depmap commons-cli commons-cli %{namedversion} JPP %{short_name}
%add_to_maven_depmap org.apache.commons commons-cli %{namedversion} JPP %{short_name}
[ "%{name}" = "%{short_name}" ] || mv %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/%{short_name}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
ln -s %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/%{short_name}
ln -s %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-%{short_name}-%{namedversion}
ln -s %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-%{short_name}

%if %with repolib
mkdir -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
cp -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
mv %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/commons-cli/commons-cli/1.2/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/commons-cli/commons-cli/%{namedversion}/ || :
rm -rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/commons-cli/commons-cli/1.2
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt NOTICE.txt README.txt RELEASE-NOTES.txt
%{_javadir}*/%{short_name}-%{namedversion}.jar
%{_javadir}*/%{short_name}.jar
%{_javadir}*/jakarta-%{short_name}-%{namedversion}.jar
%{_javadir}*/jakarta-%{short_name}.jar
%{_mavenpomdir}/JPP-%{short_name}.pom
%{_mavendepmapfragdir}/%{short_name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{short_name}-%{namedversion}
%{_javadocdir}/%{short_name}
%{_javadocdir}/jakarta-%{short_name}-%{namedversion}
%{_javadocdir}/jakarta-%{short_name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2-6.3_redhat_1.1
- Rebuild using cache signing

* Wed Dec 14 2011 David Walluck <dwalluck@redhat.com> 0:1.2-6.3
- update Summary
- forcibly fix repolib

* Wed Dec 14 2011 David Walluck <dwalluck@redhat.com> 0:1.2-6.2
- add docs
- add redhat patch
- use real file names

* Tue Jun 14 2011 David Walluck <dwalluck@redhat.com> 0:1.2-6.1
- update file list for brew

* Thu Dec 09 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.2-6
- Fix compat symlinks for jakarta-commons-cli

* Thu Oct 07 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.2-5
- Provide compat symlinks for jakarta-commons-cli

* Thu Sep 23 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.2-4
- Drop Requires for apache-commons-parent

* Wed Sep 08 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.2-3
- Add pom and depmap frag

* Wed Sep 08 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.2-2
- OK move it to free

* Wed Nov 18 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.2-1
- 1.2
- rename to apache-commons-cli
- build with maven2 by default

* Wed Mar 04 2009 Deepak Bhole <dbhole@redhat.com> - 0:1.1-2
- Fix CLI-137 -- bug that caused multiple options with same key to fail
- Update crosslink patch
- Fix error in rm command in the spec file

* Wed Jul 30 2008 David Walluck <dwalluck@redhat.com> 0:1.1-1 
- build for JPackage 5

* Mon Feb 12 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-8jpp
- Fix copyright notice dates and unnecessary macros
- Add gcj_support option

* Wed Mar 01 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.0-7jpp
- First JPP 1.7 build

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0-6jpp
- Rebuild with ant-1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-5jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:1.0-4jpp
- Upgrade to Ant 1.6.X

* Sun Oct 12 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-3jpp
- Non-versioned javadoc dir symlink.
- Crosslink with local J2SE javadocs.

* Fri Apr  4 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-2jpp
- Rebuild for JPackage 1.5.

* Tue Dec 10 2002 Ville Skyttä <ville.skytta at iki.fi> - 1.0-1jpp
- 1.0, first JPackage release.
